<?php
class ControllerExtensionPaymentScalapay extends Controller
{
    private $error = array();
    public function index()
    {
        $this->document->setTitle('Scalapay Payment Method');
        $this->load->model('setting/setting');
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            $this->model_setting_setting->editSetting('payment_scalapay', $this->request->post);

            if ($this->request->post['payment_scalapay_refund_status']) {
                $this->load->model('extension/payment/scalapay');
                $this->model_extension_payment_scalapay->install();
            }

            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $this->load->model('catalog/category');
        $all_categories = $this->model_catalog_category->getCategories(array());
        foreach ($all_categories as $result) {
            $data['categories'][] = array(
                'category_id' => $result['category_id'],
                'name'        => $result['name'],
                'parent_id'   => $result['parent_id']
            );
        }
        if (isset($this->request->post['payment_scalapay_notallowed_categories'])) {
          $data['payment_scalapay_notallowed_categories'] = $this->request->post['payment_scalapay_notallowed_categories'];
        } elseif ($this->config->get('payment_scalapay_notallowed_categories') == ''){
          $data['payment_scalapay_notallowed_categories'] = array();
        }else {
          $data['payment_scalapay_notallowed_categories'] = $this->config->get('payment_scalapay_notallowed_categories');
        }
        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }
        if (isset($this->error['companyid'])) {
            $data['error_companyid'] = $this->error['companyid'];
        } else {
            $data['error_companyid'] = '';
        }
        if (isset($this->error['encyptionkey'])) {
            $data['error_encyptionkey'] = $this->error['encyptionkey'];
        } else {
            $data['error_encyptionkey'] = '';
        }
        if (isset($this->error['test_url'])) {
            $data['error_test_url'] = $this->error['test_url'];
        } else {
            $data['error_test_url'] = '';
        }
        if (isset($this->error['production_url'])) {
            $data['error_production_url'] = $this->error['production_url'];
        } else {
            $data['error_production_url'] = '';
        }
        if (isset($this->error['installment_text'])) {
            $data['error_installment_text'] = $this->error['installment_text'];
        } else {
            $data['error_installment_text'] = '';
        }
        if (isset($this->error['installment_checkout_text'])) {
            $data['error_installment_checkout_text'] = $this->error['installment_checkout_text'];
        } else {
            $data['error_installment_checkout_text'] = '';
        }
       
        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true),
            'separator' => false
        );
        $data['breadcrumbs'][] = array(
            'text' => 'ScalaPay Payment Method',
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );
        $data['breadcrumbs'][] = array(
            'text' => 'Scalapay Payment Method',
            'href' => $this->url->link('extension/payment/scalapay', 'user_token=' . $this->session->data['user_token'], true),
            'separator' => ' :: '
        );
        $data['action'] = $this->url->link('extension/payment/scalapay', 'user_token=' . $this->session->data['user_token'], true);
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);
        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        $this->load->model('localisation/currency');
        $data['all_currency'] = $this->model_localisation_currency->getCurrencies();
        $this->load->model('localisation/language');
        $data['all_language'] = $this->model_localisation_language->getLanguages();
        $this->load->model('localisation/country');
        $data['all_countries'] = $this->model_localisation_country->getCountries();
        /***************DEFAULT CONFIG****************/
        $payment_scalapay_encyptionkey_db = $this->config->get('payment_scalapay_encyptionkey');
        if (isset($payment_scalapay_encyptionkey_db)) {
            $data['payment_scalapay_encyptionkey'] = $this->config->get('payment_scalapay_encyptionkey');
        } else {
            $data['payment_scalapay_encyptionkey'] = 'qhtfs87hjnc12kkos';
        }

        $payment_scalapay_live_encyptionkey_db = $this->config->get('payment_scalapay_live_encyptionkey');
        if (isset($payment_scalapay_live_encyptionkey_db)) {
            $data['payment_scalapay_live_encyptionkey'] = $this->config->get('payment_scalapay_live_encyptionkey');
        } else {
            $data['payment_scalapay_live_encyptionkey'] = '';
        }

        $payment_scalapay_test_url_db = $this->config->get('payment_scalapay_test_url');
        if (isset($payment_scalapay_test_url_db)) {
            $data['payment_scalapay_test_url'] = $this->config->get('payment_scalapay_test_url');
        } else {
            $data['payment_scalapay_test_url'] = 'https://integration.api.scalapay.com';
        }
        $payment_scalapay_production_url_db = $this->config->get('payment_scalapay_production_url');
        if (isset($payment_scalapay_production_url_db)) {
            $data['payment_scalapay_production_url'] = $this->config->get('payment_scalapay_production_url');
        } else {
            $data['payment_scalapay_production_url'] = 'https://api.scalapay.com';
        }
        
        $payment_scalapay_installment_checkout_text_db = $this->config->get('payment_scalapay_installment_checkout_text');
        if (isset($payment_scalapay_installment_checkout_text_db)) {
            $data['payment_scalapay_installment_checkout_text'] = $this->config->get('payment_scalapay_installment_checkout_text');
        } else {
            $data['payment_scalapay_installment_checkout_text'] = "[logo] - 3 rate da soli [price]  €";
        }
        $payment_scalapay_status_bd = $this->config->get('payment_scalapay_status');
        if (isset($payment_scalapay_status_bd)) {
            $data['payment_scalapay_status'] = $payment_scalapay_status_bd;
        } else {
            $data['payment_scalapay_status'] = 2;
        }
        $scalapay_geo_zone_id_bd = $this->config->get('scalapay_geo_zone_id');
        if (isset($scalapay_geo_zone_id_bd)) {
            $data['scalapay_geo_zone_id'] = $scalapay_geo_zone_id_bd;
        } else {
            $data['scalapay_geo_zone_id'] = 0;
        }
        if (isset($this->request->post['payment_scalapay_min_amount'])) {
          $data['payment_scalapay_min_amount'] = $this->request->post['payment_scalapay_min_amount'];
        } elseif ($this->config->get('payment_scalapay_min_amount') == '') {
          $data['payment_scalapay_min_amount'] = '5.00';
        }else{
          $data['payment_scalapay_min_amount'] = $this->config->get('payment_scalapay_min_amount'); 
        }
        if (isset($this->request->post['payment_scalapay_max_amount'])) {
          $data['payment_scalapay_max_amount'] = $this->request->post['payment_scalapay_max_amount'];
        } elseif ($this->config->get('payment_scalapay_max_amount') == '') {
          $data['payment_scalapay_max_amount'] = '300.00';
        }else{
          $data['payment_scalapay_max_amount'] = $this->config->get('payment_scalapay_max_amount'); 
        }
        if (isset($this->request->post['payment_scalapay_number_of_payments'])) {
          $data['payment_scalapay_number_of_payments'] = $this->request->post['payment_scalapay_number_of_payments'];
        } elseif ($this->config->get('payment_scalapay_number_of_payments') == '') {
          $data['payment_scalapay_number_of_payments'] = '3';
        }else{
         $data['payment_scalapay_number_of_payments'] = $this->config->get('payment_scalapay_number_of_payments');  
        }
        if (isset($this->request->post['payment_scalapay_product_logo_size'])) {
          $data['payment_scalapay_product_logo_size'] = $this->request->post['payment_scalapay_product_logo_size'];
        } else {
          $data['payment_scalapay_product_logo_size'] = $this->config->get('payment_scalapay_product_logo_size');
        }
        $payment_scalapay_product_logo_color_bd = $this->config->get('payment_scalapay_product_logo_color');
        if (isset($this->request->post['payment_scalapay_product_logo_color'])) {
          $data['payment_scalapay_product_logo_color'] = $this->request->post['payment_scalapay_product_logo_color'];
        } elseif (isset($payment_scalapay_product_logo_color_bd)) {
            $data['payment_scalapay_product_logo_color'] = $payment_scalapay_product_logo_color_bd;
        } else {
          $data['payment_scalapay_product_logo_color'] = 'black';
        }
        if (isset($this->request->post['payment_scalapay_product_logo_alignment'])) {
          $data['payment_scalapay_product_logo_alignment'] = $this->request->post['payment_scalapay_product_logo_alignment'];
        } else {
          $data['payment_scalapay_product_logo_alignment'] = $this->config->get('payment_scalapay_product_logo_alignment');
        }
        $payment_scalapay_product_logo_price_color_bd = $this->config->get('payment_scalapay_product_logo_price_color');
        if (isset($this->request->post['payment_scalapay_product_logo_price_color'])) {
          $data['payment_scalapay_product_logo_price_color'] = $this->request->post['payment_scalapay_product_logo_price_color'];
        } elseif(isset($payment_scalapay_product_logo_price_color_bd)){
            $data['payment_scalapay_product_logo_price_color'] = $this->config->get('payment_scalapay_product_logo_price_color');
        } else {
          $data['payment_scalapay_product_logo_price_color'] = 'black';
        }
        if (isset($this->request->post['payment_scalapay_product_showhide_logo'])) {
          $data['payment_scalapay_product_showhide_logo'] = $this->request->post['payment_scalapay_product_showhide_logo'];
        } elseif ($this->config->get('payment_scalapay_product_showhide_logo') == ''){
          $data['payment_scalapay_product_showhide_logo'] = 'false';
        } else {
          $data['payment_scalapay_product_showhide_logo'] = $this->config->get('payment_scalapay_product_showhide_logo');
        }
        if (isset($this->request->post['payment_scalapay_cart_logo_size'])) {
          $data['payment_scalapay_cart_logo_size'] = $this->request->post['payment_scalapay_cart_logo_size'];
        } else {
          $data['payment_scalapay_cart_logo_size'] = $this->config->get('payment_scalapay_cart_logo_size');
        }
        $payment_scalapay_cart_logo_color_bd = $this->config->get('payment_scalapay_cart_logo_color');
        if (isset($this->request->post['payment_scalapay_cart_logo_color'])) {
          $data['payment_scalapay_cart_logo_color'] = $this->request->post['payment_scalapay_cart_logo_color'];
        } elseif(isset($payment_scalapay_cart_logo_color_bd)){
            $data['payment_scalapay_cart_logo_color'] = $this->config->get('payment_scalapay_cart_logo_color');
        }else {
          $data['payment_scalapay_cart_logo_color'] = 'black';
        }
        if (isset($this->request->post['payment_scalapay_cart_logo_alignment'])) {
          $data['payment_scalapay_cart_logo_alignment'] = $this->request->post['payment_scalapay_cart_logo_alignment'];
        } else {
          $data['payment_scalapay_cart_logo_alignment'] = $this->config->get('payment_scalapay_cart_logo_alignment');
        }
        $payment_scalapay_cart_logo_price_color = $this->config->get('payment_scalapay_cart_logo_price_color');
        if (isset($this->request->post['payment_scalapay_cart_logo_price_color'])) {
          $data['payment_scalapay_cart_logo_price_color'] = $this->request->post['payment_scalapay_cart_logo_price_color'];
        }elseif(isset($payment_scalapay_cart_logo_price_color)){
            $data['payment_scalapay_cart_logo_price_color'] = $this->config->get('payment_scalapay_cart_logo_price_color');
        } else {
          $data['payment_scalapay_cart_logo_price_color'] = 'black';
        }
        if (isset($this->request->post['payment_scalapay_cart_showhide_logo'])) {
          $data['payment_scalapay_cart_showhide_logo'] = $this->request->post['payment_scalapay_cart_showhide_logo'];
        } elseif ($this->config->get('payment_scalapay_cart_showhide_logo') == ''){
          $data['payment_scalapay_cart_showhide_logo'] = 'false';
        } else {
          $data['payment_scalapay_cart_showhide_logo'] = $this->config->get('payment_scalapay_cart_showhide_logo');
        }
        if (isset($this->request->post['payment_scalapay_cart_size'])) {
          $data['payment_scalapay_cart_size'] = $this->request->post['payment_scalapay_cart_size'];
        } else {
          $data['payment_scalapay_cart_size'] = $this->config->get('payment_scalapay_cart_size');
        }
        if (isset($this->request->post['payment_scalapay_product_size'])) {
          $data['payment_scalapay_product_size'] = $this->request->post['payment_scalapay_product_size'];
        } else {
          $data['payment_scalapay_product_size'] = $this->config->get('payment_scalapay_product_size');
        }
        if (isset($this->request->post['payment_scalapay_cart_price_selector'])) {
          $data['payment_scalapay_cart_price_selector'] = $this->request->post['payment_scalapay_cart_price_selector'];
        } else {
          $data['payment_scalapay_cart_price_selector'] = $this->config->get('payment_scalapay_cart_price_selector');
        }
        if (isset($this->request->post['payment_scalapay_product_price_selector'])) {
          $data['payment_scalapay_product_price_selector'] = $this->request->post['payment_scalapay_product_price_selector'];
        } else {
          $data['payment_scalapay_product_price_selector'] = $this->config->get('payment_scalapay_product_price_selector');
        }

        if (isset($this->request->post['payment_scalapay_cart_pricebox_selector'])) {
          $data['payment_scalapay_cart_pricebox_selector'] = $this->request->post['payment_scalapay_cart_pricebox_selector'];
        } else {
          $data['payment_scalapay_cart_pricebox_selector'] = $this->config->get('payment_scalapay_cart_pricebox_selector');
        }
        if (isset($this->request->post['payment_scalapay_product_pricebox_selector'])) {
          $data['payment_scalapay_product_pricebox_selector'] = $this->request->post['payment_scalapay_product_pricebox_selector'];
        } else {
          $data['payment_scalapay_product_pricebox_selector'] = $this->config->get('payment_scalapay_product_pricebox_selector');
        }

        if (isset($this->request->post['payment_scalapay_mode'])) {
          $data['payment_scalapay_mode'] = $this->request->post['payment_scalapay_mode'];
        } else {
          $data['payment_scalapay_mode'] = $this->config->get('payment_scalapay_mode');
        }
        $payment_scalapay_countries_bd = $this->config->get('payment_scalapay_countries');
        if (isset($payment_scalapay_countries_bd)) {
            $data['payment_scalapay_countries'] = $payment_scalapay_countries_bd;
        } else {
            $data['payment_scalapay_countries'] = 0;
        }
        //currency
        $payment_scalapay_currencies_bd = $this->config->get('payment_scalapay_currencies');
        if (isset($this->request->post['payment_scalapay_currencies'])) {
            $data['payment_scalapay_currencies'] = $this->request->post['payment_scalapay_currencies'];
        }
        elseif (isset($payment_scalapay_currencies_bd)) {
            $data['payment_scalapay_currencies'] = $payment_scalapay_currencies_bd;
        }
        else {
            $data['payment_scalapay_currencies'] = 0;
        }
        //language
        $payment_scalapay_languages_bd = $this->config->get('payment_scalapay_languages');
        if (isset($this->request->post['payment_scalapay_languages'])) {
            $data['payment_scalapay_languages'] = $this->request->post['payment_scalapay_languages'];
        }
        elseif (isset($payment_scalapay_languages_bd)) {
            $data['payment_scalapay_languages'] = $payment_scalapay_languages_bd;
        } else {
            $data['payment_scalapay_languages'] = 0;
        }
        $payment_scalapay_sort_order_bd = $this->config->get('payment_scalapay_sort_order');
        if (isset($payment_scalapay_sort_order_bd)) {
            $data['payment_scalapay_sort_order'] = $payment_scalapay_sort_order_bd;
        } else {
            $data['payment_scalapay_sort_order'] = 0;
        }
        if (isset($this->request->post['payment_scalapay_logo_css'])) {
            $data['payment_scalapay_logo_css'] = $this->request->post['payment_scalapay_logo_css'];
        } elseif ($this->config->get('payment_scalapay_logo_css') == "") {
            $data['payment_scalapay_logo_css'] = "
            .scalapay_logo_checkout_view{
                display: inline !important;border: none !important;box-shadow: none !important;vertical-align: middle !important;
                background: none !important;padding: 0 !important;float: none;width: 90px !important;
            }@media (max-width: 767px)
            {
            
            .scalapay_logo_checkout_view{
                display: inline !important;border: none !important;box-shadow: none !important;vertical-align: middle !important;
                background: none !important;padding: 0 !important;float: none;width: 90px !important;
            }
            
            }";
        } else {
            $data['payment_scalapay_logo_css'] = $this->config->get('payment_scalapay_logo_css');
        }
        $payment_scalapay_completed_status_id_db = $this->config->get('payment_scalapay_completed_status_id');
        if (isset($payment_scalapay_completed_status_id_db)) {
            $data['payment_scalapay_completed_status_id'] = $payment_scalapay_completed_status_id_db;
        } else {
            $data['payment_scalapay_completed_status_id'] = 2;
        }


        if (isset($this->request->post['payment_scalapay_product_page_apply_min_order_value'])) {
            $data['payment_scalapay_product_page_apply_min_order_value'] = $this->request->post['payment_scalapay_product_page_apply_min_order_value'];
        } elseif ($this->config->get('payment_scalapay_product_page_apply_min_order_value') == '') {
            $data['payment_scalapay_product_page_apply_min_order_value'] = 'false';
        }else{
            $data['payment_scalapay_product_page_apply_min_order_value'] = $this->config->get('payment_scalapay_product_page_apply_min_order_value');
        }

        if (isset($this->request->post['payment_scalapay_cart_page_apply_min_order_value'])) {
            $data['payment_scalapay_cart_page_apply_min_order_value'] = $this->request->post['payment_scalapay_cart_page_apply_min_order_value'];
        } elseif ($this->config->get('payment_scalapay_cart_page_apply_min_order_value') == '') {
            $data['payment_scalapay_cart_page_apply_min_order_value'] = 'false';
        }else{
            $data['payment_scalapay_cart_page_apply_min_order_value'] = $this->config->get('payment_scalapay_cart_page_apply_min_order_value');
        }

        if (isset($this->request->post['payment_scalapay_product_hide_price'])) {
            $data['payment_scalapay_product_hide_price'] = $this->request->post['payment_scalapay_product_hide_price'];
        } elseif ($this->config->get('payment_scalapay_product_hide_price') == '') {
            $data['payment_scalapay_product_hide_price'] = 'false';
        }else{
            $data['payment_scalapay_product_hide_price'] = $this->config->get('payment_scalapay_product_hide_price');
        }

        if (isset($this->request->post['payment_scalapay_cart_hide_price'])) {
            $data['payment_scalapay_cart_hide_price'] = $this->request->post['payment_scalapay_cart_hide_price'];
        } elseif ($this->config->get('payment_scalapay_cart_hide_price') == '') {
            $data['payment_scalapay_cart_hide_price'] = 'false';
        }else{
            $data['payment_scalapay_cart_hide_price'] = $this->config->get('payment_scalapay_cart_hide_price');
        }


        if (isset($this->request->post['payment_scalapay_refund_status'])) {
            $data['payment_scalapay_refund_status'] = $this->request->post['payment_scalapay_refund_status'];
        } elseif ($this->config->get('payment_scalapay_refund_status') == '') {
            $data['payment_scalapay_refund_status'] = 'false';
        }else{
            $data['payment_scalapay_refund_status'] = $this->config->get('payment_scalapay_refund_status');
        }

        $admin_language = explode("-",$this->config->get('config_admin_language'));
        $data['admin_language'] = $admin_language[0];
        /*********************************/
        $data['user_token'] = $this->session->data['user_token'];
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');
        $this->response->setOutput($this->load->view('extension/payment/scalapay', $data));
    }
    private function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/scalapay')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        if (isset($this->request->post['payment_scalapay_encyptionkey'])) {
            $data['payment_scalapay_encyptionkey'] = $this->request->post['payment_scalapay_encyptionkey'];
        } else {
            $data['payment_scalapay_encyptionkey'] = $this->config->get('payment_scalapay_encyptionkey');
        }

        if (isset($this->request->post['payment_scalapay_live_encyptionkey'])) {
            $data['payment_scalapay_live_encyptionkey'] = $this->request->post['payment_scalapay_live_encyptionkey'];
        } else {
            $data['payment_scalapay_live_encyptionkey'] = $this->config->get('payment_scalapay_live_encyptionkey');
        }

        if (isset($this->request->post['payment_scalapay_test_url'])) {
            $data['payment_scalapay_test_url'] = $this->request->post['payment_scalapay_test_url'];
        } else {
            $data['payment_scalapay_test_url'] = $this->config->get('payment_scalapay_test_url');
        }
        if (isset($this->request->post['payment_scalapay_production_url'])) {
            $data['payment_scalapay_production_url'] = $this->request->post['payment_scalapay_production_url'];
        } else {
            $data['payment_scalapay_production_url'] = $this->config->get('payment_scalapay_production_url');
        }
        if (isset($this->request->post['payment_scalapay_installment_text'])) {
            $data['payment_scalapay_installment_text'] = $this->request->post['payment_scalapay_installment_text'];
        } else {
            $data['payment_scalapay_installment_text'] = $this->config->get('payment_scalapay_installment_text');
        }
        if (isset($this->request->post['payment_scalapay_installment_checkout_text'])) {
            $data['payment_scalapay_installment_checkout_text'] = $this->request->post['payment_scalapay_installment_checkout_text'];
        } else {
            $data['payment_scalapay_installment_checkout_text'] = $this->config->get('payment_scalapay_installment_checkout_text');
        }
        if (isset($this->request->post['payment_scalapay_completed_status_id'])) {
            $data['payment_scalapay_completed_status_id'] = $this->request->post['payment_scalapay_completed_status_id'];
        } else {
            $data['payment_scalapay_completed_status_id'] = $this->config->get('payment_scalapay_completed_status_id');
        }
        if (isset($this->request->post['payment_scalapay_status'])) {
            $data['payment_scalapay_status'] = $this->request->post['payment_scalapay_status'];
        } else {
            $data['payment_scalapay_status'] = $this->config->get('payment_scalapay_status');
        }
        if (isset($this->request->post['scalapay_geo_zone_id'])) {
            $data['scalapay_geo_zone_id'] = $this->request->post['scalapay_geo_zone_id'];
        } else {
            $data['scalapay_geo_zone_id'] = $this->config->get('scalapay_geo_zone_id');
        }
        $this->load->model('localisation/geo_zone');
        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
        if (isset($this->request->post['payment_scalapay_countries'])) {
            $data['payment_scalapay_countries'] = $this->request->post['payment_scalapay_countries'];
        } else {
            $data['payment_scalapay_countries'] = $this->config->get('payment_scalapay_countries');
        }
        //currency
        if (isset($this->request->post['payment_scalapay_currencies'])) {
            $data['payment_scalapay_currencies'] = $this->request->post['payment_scalapay_currencies'];
        } else {
            $data['payment_scalapay_currencies'] = $this->config->get('payment_scalapay_currencies');
        }
        //language
        if (isset($this->request->post['config_scapalay_languages'])) {
            $data['payment_scapalay_languages'] = $this->request->post['payment_scapalay_languages'];
        } else {
            $data['payment_scapalay_allowed_languages'] = $this->config->get('payment_scapalay_languages');
        }
        if (isset($this->request->post['payment_scalapay_sort_order'])) {
            $data['payment_scalapay_sort_order'] = $this->request->post['payment_scalapay_sort_order'];
        } else {
            $data['payment_scalapay_sort_order'] = $this->config->get('payment_scalapay_sort_order');
        }
        if (isset($this->request->post['payment_scalapay_logo_css'])) {
            $data['payment_scalapay_logo_css'] = $this->request->post['payment_scalapay_logo_css'];
        } else {
            $data['payment_scalapay_logo_css'] = $this->config->get('payment_scalapay_logo_css');
        }
        if (isset($this->request->post['payment_scalapay_popup_image_desktop'])) {
            $data['payment_scalapay_popup_image_desktop'] = $this->request->post['payment_scalapay_popup_image_desktop'];
        } else {
            $data['payment_scalapay_popup_image_desktop'] = $this->config->get('payment_scalapay_popup_image_desktop');
        }
        if (isset($this->request->post['payment_scalapay_popup_image_mobile'])) {
            $data['payment_scalapay_popup_image_mobile'] = $this->request->post['payment_scalapay_popup_image_mobile'];
        } else {
            $data['payment_scalapay_popup_image_mobile'] = $this->config->get('payment_scalapay_popup_image_mobile');
        }
        if (!$this->user->hasPermission('modify', 'extension/payment/scalapay')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        if (!empty($this->request->files['payment_scalapay_popup_image_desktop']['name']) && is_file($this->request->files['payment_scalapay_popup_image_desktop']['tmp_name'])) {
            $filename = html_entity_decode($this->request->files['payment_scalapay_popup_image_desktop']['name'], ENT_QUOTES, 'UTF-8');
            $file = $filename;
            move_uploaded_file($this->request->files['payment_scalapay_popup_image_desktop']['tmp_name'], DIR_UPLOAD . $file);
            // Hide the uploaded file name so people can not link to it directly.
            $this->load->model('tool/upload');
            $this->model_tool_upload->addUpload($filename, $file);
        }
        if (!empty($this->request->files['payment_scalapay_popup_image_mobile']['name']) && is_file($this->request->files['payment_scalapay_popup_image_mobile']['tmp_name'])) {
            $filename = html_entity_decode($this->request->files['payment_scalapay_popup_image_mobile']['name'], ENT_QUOTES, 'UTF-8');
            $file = $filename;
            move_uploaded_file($this->request->files['payment_scalapay_popup_image_mobile']['tmp_name'], DIR_UPLOAD . $file);
            // Hide the uploaded file name so people can not link to it directly.
            $this->load->model('tool/upload');
            $this->model_tool_upload->addUpload($filename, $file);
        }
        return !$this->error;
    }
    
    public function install()
    {
        //$this->load->model('extension/payment/scalapay');
        //$this->model_extension_payment_scalapay->install();
    }

    public function uninstall()
    {
        $this->load->model('extension/payment/scalapay');
        $this->model_extension_payment_scalapay->uninstall();
    }

    public function refund(){

        $this->load->language('sale/order');
        $this->load->model('sale/order');

        if (isset($this->request->get['order_id'])) {
            $order_id = $this->request->get['order_id'];
        } else {
            $order_id = 0;
        }
        

        $logger = new Log('scalapay_admin_refund_logs.log'); //just passed the file name as file_name.log
        $logger->write($this->request->post); // again $data contains the data the need to be log

        $order_info = $this->model_sale_order->getOrder($order_id);

        if($order_info){

            $totals = $this->model_sale_order->getOrderTotals($order_id);

            foreach ($totals as $total) {
                if($total['code'] == 'total')
                    $order_grand_total = $this->currency->format($total['value'], $order_info['currency_code'], $order_info['currency_value']);
            }
            
            $order_total = $this->request->post['total_refund'];
            $order_grand_total = str_replace("€", "", $order_grand_total);
            $logger->write($order_grand_total); // again $data contains the data the need to be log

            $json_array = array();
            $json_array["refundAmount"]["amount"] = $order_total;
            $json_array["refundAmount"]["currency"] = $order_info['currency_code'];
            $json_array["merchantReference"] = $this->request->get['order_id'];

            $data['histories'] = array();
            $results = $this->model_sale_order->getOrderHistories($order_id);

            if ( sizeof($results) <=1 ) {

                $get_order_token = $results[0]['comment'];
                $get_order_token = trim(str_replace("Scalapay order token: ", "", $get_order_token));
            }
            else {
                foreach($results as $result) {

                    if (strpos($result['comment'], 'Scalapay order token') !== false) {
                        $get_order_token = $result['comment'];
                        $get_order_token = trim(str_replace("Scalapay order token: ", "", $get_order_token));
                    }


                }
            }
        }

        $post_string = json_encode($json_array);

        $mode = $this->config->get('payment_scalapay_mode');
        if ($mode) {
            $ctp_url = $this->config->get('payment_scalapay_production_url') . '/v2/payments/'.$get_order_token.'/refund';
            $password = $this->config->get('payment_scalapay_live_encyptionkey');
        } else {
            $ctp_url = $this->config->get('payment_scalapay_test_url') . '/v2/payments/'.$get_order_token.'/refund';
            $password = $this->config->get('payment_scalapay_encyptionkey');
        }
        $authorization = "Authorization: Bearer " . $password;
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "$ctp_url",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "$post_string",
            CURLOPT_HTTPHEADER => array(
                "Accept: application/json",
                "Content-Type: application/json",
                $authorization
            ),
        ));
        $response = curl_exec($curl);
        curl_close($curl);
        $response_decode = json_decode($response, true);
        $json = array();
        if (isset($response_decode["error"]) && $response_decode["error"] != "") {
            $error_message = "Siamo davvero spiacenti, ma questo ordine non può essere approvato da Scalapay. Il pagamento non è andato a buon fine. Scegliere un altro metodo di pagamento.";
            $json['error'] = $error_message;
        }else if(isset($response_decode["errorCode"]) && $response_decode["errorCode"] != ""){
            $error_message = $response_decode['message'];
            $json['error'] =  $error_message;
        }else{
            // 11 is normally refunded status
            $logger->write('Refund total'); // again $data contains the data the need to be log
            $logger->write($order_grand_total); // again $data contains the data the need to be log
            $this->addOrderHistory($this->request->get['order_id'], 11);
            $this->addTransaction($this->request->get['order_id'],$order_grand_total ,$order_total);  
            $json['success'] = $this->language->get('text_success'); 
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }
    private function addTransaction($order_id,$order_total, $refunded_total) {
        $this->db->query("INSERT INTO `" . DB_PREFIX . "scalapay_refund_orders` SET `order_id` = '" . (int)$order_id . "', `order_total` = '" . (double)$order_total . "', `refunded_amount` = '" . (double)$refunded_total . "'");
    }
    private function addOrderHistory($order_id, $order_status_id) {
        $this->db->query("UPDATE `" . DB_PREFIX . "order` SET order_status_id = '" . (int)$order_status_id . "', date_modified = NOW() WHERE order_id = '" . (int)$order_id . "'");
        $this->db->query("INSERT INTO " . DB_PREFIX . "order_history SET order_id = '" . (int)$order_id . "', order_status_id = '" . (int)$order_status_id . "', date_added = NOW()");
    }

    private function formatScalapay($number, $currency, $value = '', $format = true) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "currency");
        $currencies = array();
        foreach ($query->rows as $result) {
            $currencies[$result['code']] = array(
                'currency_id'   => $result['currency_id'],
                'title'         => $result['title'],
                'symbol_left'   => $result['symbol_left'],
                'symbol_right'  => $result['symbol_right'],
                'decimal_place' => $result['decimal_place'],
                'value'         => $result['value']
            );
        }
        $symbol_left = $currencies[$currency]['symbol_left'];
        $symbol_right = $currencies[$currency]['symbol_right'];
        $decimal_place = $currencies[$currency]['decimal_place'];

        if (!$value) {
            $value = $currencies[$currency]['value'];
        }

        $amount = $value ? (float)$number * $value : (float)$number;
        
        $amount = round($amount, (int)$decimal_place);
        
        if (!$format) {
            return $amount;
        }

        $string = '';
        $string .= number_format($amount, (int)$decimal_place, '.', ',');

        return $string;
    }
}
