<?php

class ControllerExtensionPaymentScalapay extends Controller
{
    const API_VERSION = 2;
    const SCALAPAY_PLUGIN_VERSION = '1.1.29';

    public function index()
    {
        $this->language->load('extension/payment/scalapay');
        $this->load->model('checkout/order');
        // Getting order details using order id from session
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        if ($order_info) {
            $data['button_confirm'] = $this->language->get('button_confirm');
            //This function will use to get order information and use it in a payload data.
            $data['checkoutURL'] = $this->generateToken();
            $data['action'] = $data['checkoutURL'];
            $data['token_error'] = $this->language->get('token_error');
            $data['order_id'] = $this->session->data['order_id'];
            return $this->load->view('extension/payment/scalapay', $data);
        }
    }

    /*
    * Setting Callback parameters in it.
    * Using order information, we will create payload data and pass it to place an order on scalapay.
    */
    public function generateToken()
    {
        $this->load->model('checkout/order');
        $this->load->model('catalog/product');
        $this->load->model('catalog/category');
        $this->load->model('extension/payment/scalapay');

        // Get order information using order id from session
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $scalapay_order_id = $this->session->data['order_id'];
        $scalapay_payment_method = "Scalapay";
        //Verifing order id and updating payment method
        if (isset($scalapay_order_id) && $scalapay_order_id > 0) {
            $this->db->query("UPDATE `" . DB_PREFIX . "order` SET `payment_method` = '" . $this->db->escape($scalapay_payment_method) . "' WHERE `order_id` = '" . $this->db->escape($scalapay_order_id) . "' ");
        }
        $cart_proucts = $this->cart->getProducts();
        $orderAmount = $this->currency->format($order_info['total'], $order_info['currency_code'],
            $order_info['currency_value'], false);
        $orderAmount = (float)$orderAmount * pow(10,
                (int)$this->currency->getDecimalPlace($order_info['currency_code']));
        $orderAmount = intval(strval($orderAmount));
        //Creating array of customer data using order information already created.
        $customer_array = array(
            'address' => strlen($order_info['payment_address_1']) > 0 ? $order_info['payment_address_1'] : null,
            'first_name' => strlen($order_info['payment_firstname']) > 0 ? $order_info['payment_firstname'] : null,
            'last_name' => strlen($order_info['payment_lastname']) > 0 ? $order_info['payment_lastname'] : null,
            'country' => strlen($order_info['payment_iso_code_2']) > 0 ? $order_info['payment_iso_code_2'] : null,
            'city' => strlen($order_info['payment_city']) > 0 ? $order_info['payment_city'] : null,
            'phone' => strlen($order_info['telephone']) > 0 ? $order_info['telephone'] : null,
            'email' => strlen($order_info['email']) > 0 ? $order_info['email'] : null,
            'zip' => strlen($order_info['payment_postcode']) > 0 ? $order_info['payment_postcode'] : null,
            'ip' => $this->request->server['REMOTE_ADDR'],
            'shipping_firstname' => strlen($order_info['shipping_firstname']) > 0 ? $order_info['shipping_firstname'] : null,
            'shipping_lastname' => strlen($order_info['shipping_lastname']) > 0 ? $order_info['shipping_lastname'] : null,
            'shipping_address_1' => strlen($order_info['shipping_address_1']) > 0 ? $order_info['shipping_address_1'] : null,
            'shipping_address_2' => strlen($order_info['shipping_address_2']) > 0 ? $order_info['shipping_address_2'] : null,
            'shipping_postcode' => strlen($order_info['shipping_postcode']) > 0 ? $order_info['shipping_postcode'] : null,
            'shipping_city' => strlen($order_info['shipping_city']) > 0 ? $order_info['shipping_city'] : null,
            'shipping_zone_id' => strlen($order_info['shipping_zone_id']) > 0 ? $order_info['shipping_zone_id'] : null,
            'shipping_zone' => strlen($order_info['shipping_zone']) > 0 ? $order_info['shipping_zone'] : null,
            'shipping_country' => strlen($order_info['shipping_country']) > 0 ? $order_info['shipping_country'] : null,
            'shipping_country_id' => strlen($order_info['shipping_country']) > 0 ? $order_info['shipping_country_id'] : null,
            'shipping_iso_code_2' => strlen($order_info['shipping_iso_code_2']) > 0 ? $order_info['shipping_iso_code_2'] : null,
            'shipping_iso_code_3' => strlen($order_info['shipping_iso_code_3']) > 0 ? $order_info['shipping_iso_code_3'] : null
        );
        if (in_array($order_info['payment_iso_code_2'], array('US', 'CA'))) {
            $customer_array['state'] = $order_info['payment_zone_code'];
        }
        $order_array = array(
            'currency' => $order_info['currency_code'],
            'amount' => $orderAmount,
            'description' => $this->language->get('text_order') . ' ' . $order_info['order_id'],
            'tracking_id' => $order_info['order_id']
        );
        $callback_url = $this->url->link('extension/payment/scalapay/callback1', '', 'SSL');
        $openCartId = $order_info['order_id'];
        $grandTotal = $order_array["amount"] / 100;
        //Payment variable settings.
        $setting_array = array(
            'success_url' => $this->url->link('extension/payment/scalapay/callback' . "&cart_id=" . $openCartId . "&total=" . $grandTotal,
                '', 'SSL'),
            'decline_url' => $this->url->link('checkout/checkout', '', 'SSL'),
            'cancel_url' => $this->url->link('checkout/checkout', '', 'SSL'),
            'fail_url' => $this->url->link('checkout/checkout', '', 'SSL'),
            'language' => $this->_language($this->session->data['language']),
            'notification_url' => $callback_url
        );
        $transaction_type = 'payment';
        $payment_methods_array = array(
            'types' => array()
        );

        $checkout_array = array(
            'version' => '2.1',
            'transaction_type' => $transaction_type,
            'settings' => $setting_array,
            'order' => $order_array,
            'customer' => $customer_array,
            'payment_method' => $payment_methods_array
        );
        $token_json = array('checkout' => $checkout_array);
        $this->load->model('checkout/order');
        //Creating payload data using already created variables and arrays.
        $json_array = array();
        $grandTotal = $order_array["amount"] / 100;
        $currency = $order_array["currency"];
        $json_array["totalAmount"]["amount"] = "$grandTotal";
        $json_array["totalAmount"]["currency"] = "$currency";
        //customer

        if ( isset($customer_array["phone"]) && !empty($customer_array["phone"])) {
            $json_array["consumer"]["phoneNumber"] = $customer_array["phone"];
        }

        if ( isset($customer_array["first_name"]) && !empty($customer_array["first_name"])) {
            $json_array["consumer"]["givenNames"] = $customer_array["first_name"];
        }

        if ( isset($customer_array["last_name"]) && !empty($customer_array["last_name"])) {
            $json_array["consumer"]["surname"] = $customer_array["last_name"];
        }

        if ( isset($customer_array["email"]) && !empty($customer_array["email"])) {
           $json_array["consumer"]["email"] = $customer_array["email"];
        }


        //billing
        if ( isset($customer_array["first_name"]) && !empty($customer_array["first_name"])) {
            $json_array["billing"]["name"] = $customer_array["first_name"] . " " . $customer_array["last_name"];
        }

        if ( isset($customer_array["address"]) && !empty($customer_array["address"])) {
           $json_array["billing"]["line1"] = $customer_array["address"];
        }

        if ( isset($customer_array["city"]) && !empty($customer_array["city"])) {
           $json_array["billing"]["suburb"] = $customer_array["city"];
        }

        if ( isset($customer_array["city"]) && !empty($customer_array["city"])) {
            $json_array["billing"]["state"] = $customer_array["city"];
        }

        if ( isset($customer_array["zip"]) && !empty($customer_array["zip"])) {
            $json_array["billing"]["postcode"] = $customer_array["zip"];
        }

        if ( isset($customer_array["country"]) && !empty($customer_array["country"])) {
           $json_array["billing"]["countryCode"] = $customer_array["country"];
        }

        if ( isset($customer_array["phone"]) && !empty($customer_array["phone"])) {
            $json_array["billing"]["phoneNumber"] = $customer_array["phone"];
        }

        //shipping info
        if ( isset($customer_array["shipping_firstname"]) && !empty($customer_array["shipping_firstname"])) {
            $json_array["shipping"]["name"] = $customer_array["shipping_firstname"] . " " . $customer_array["shipping_lastname"];
        }

        if ( isset($customer_array["shipping_address_1"]) && !empty($customer_array["shipping_address_1"])) {
            $json_array["shipping"]["line1"] = $customer_array["shipping_address_1"];
        }

        if ( isset($customer_array["shipping_city"]) && !empty($customer_array["shipping_city"])) {
            $json_array["shipping"]["suburb"] = $customer_array["shipping_city"];
        }

        if ( isset($customer_array["shipping_zone"]) && !empty($customer_array["shipping_zone"])) {
            $json_array["shipping"]["state"] = $customer_array["shipping_zone"];
        }

        if ( isset($customer_array["shipping_postcode"]) && !empty($customer_array["shipping_postcode"])) {
            $json_array["shipping"]["postcode"] = $customer_array["shipping_postcode"];
        }

        if ( isset($customer_array["shipping_iso_code_2"]) && !empty($customer_array["shipping_iso_code_2"])) {
            $json_array["shipping"]["countryCode"] = $customer_array["shipping_iso_code_2"];
        }

        if ( isset($customer_array["phone"]) && !empty($customer_array["phone"])) {
            $json_array["shipping"]["phoneNumber"] = $customer_array["phone"];
        }
        
        

        foreach ($cart_proucts as $item) {

            $product = $this->model_catalog_product->getProduct($item['product_id']);
            // product variables are as fallow. model, sku, upc, ean, jan, isbn, mpn, manufacturer

            $product_categories = $this->model_extension_payment_scalapay->getCurrentProductCategories($item['product_id']);
            $categories = $this->model_extension_payment_scalapay->getProductParentCategory($product_categories,
                array());
            $sub_categories = $this->model_extension_payment_scalapay->getProductSubCategories($product_categories,
                array());

            $item_price = $this->currency->format($item['price'], $order_info['currency_code'], false, false);

            $scalapay_item = array();

            if ( isset($item["name"]) && !empty($item["name"])) {
                $scalapay_item["name"] = $item["name"];
            }

            if ( isset($product["sku"]) && !empty($product["sku"])) {
                $scalapay_item["sku"] = $product["sku"];
            }

            if ( isset($product["upc"]) && !empty($product["upc"])) {
                $scalapay_item["gtin"] = $product['upc'];
            }

            if ( isset($product["manufacturer"]) && !empty($product["manufacturer"])) {
                $scalapay_item["brand"] = $product['manufacturer'];
            }

            if ( isset($categories) && !empty($categories)) {
               $scalapay_item["category"] = "$categories";
            }

            if ( isset($sub_categories) && !empty($sub_categories)) {
               $scalapay_item["subcategory"] = $sub_categories;
            }
            
            if ( isset($item["quantity"]) && !empty($item["quantity"])) {
               $scalapay_item["quantity"] = $item["quantity"];
            }

            if (isset($item_price)) {
               $scalapay_item["price"]["amount"] = "$item_price";
               $scalapay_item["price"]["currency"] = "$currency";
            }
            

            $json_array["items"][] = $scalapay_item;
        }

        // Gift Voucher
        $data['vouchers'] = array();
        if (!empty($this->session->data['vouchers'])) {
            foreach ($this->session->data['vouchers'] as $key => $voucher) {
                $this->data['vouchers'][] = array(
                    'key' => $key,
                    'description' => $voucher['description'],
                    'amount' => $this->currency->format($voucher['amount']),
                    'remove' => $this->url->link('checkout/cart', 'remove=' . $key)
                );
            }
        }

        // Totals
        $this->load->model('setting/extension');

        $totals = array();
        $taxes = $this->cart->getTaxes();
        $total = 0;

        // Because __call can not keep var references so we put them into an array.
        $total_data = array(
            'totals' => &$totals,
            'taxes'  => &$taxes,
            'total'  => &$total
        );

        // Display prices
        if ($this->customer->isLogged() || !$this->config->get('config_customer_price')) {
            $sort_order = array();

            $results = $this->model_setting_extension->getExtensions('total');

            foreach ($results as $key => $value) {
                $sort_order[$key] = $this->config->get('total_' . $value['code'] . '_sort_order');
            }

            array_multisort($sort_order, SORT_ASC, $results);

            foreach ($results as $result) {
                if ($this->config->get('total_' . $result['code'] . '_status')) {
                    $this->load->model('extension/total/' . $result['code']);

                    // We have to put the totals in an array so that they pass by reference.
                    $this->{'model_extension_total_' . $result['code']}->getTotal($total_data);
                }
            }

            $sort_order = array();

            foreach ($totals as $key => $value) {
                $sort_order[$key] = $value['sort_order'];
            }

            array_multisort($sort_order, SORT_ASC, $totals);
        }

        //discount
        $discounts_item = array();
        foreach ($totals as $key => $value) {
            if ($value["code"] == "Coupon" || $value["code"] == "coupon") {
                $coupons_amount = abs($this->currency->format($value['value'], $order_info['currency_code'],
                    $order_info['currency_value'], false));
                $discounts_item["displayName"] = $value['title'];

                $discounts_item["amount"]["amount"] = "$coupons_amount";
                $discounts_item["amount"]["currency"] = "$currency";
                $json_array["discounts"][] = $discounts_item;
            }
        }
        //tax
        $taxAmount = $this->cart->getTaxes();
        $totalTaxAmount = 0;

        if ($taxAmount && !empty($taxAmount) && is_array($taxAmount) && sizeof($taxAmount) > 0) {
            foreach ($taxAmount as $tax) {
                $totalTaxAmount += $this->currency->format($tax, $order_info['currency_code'], $order_info['currency_value'],
                    false);
            }
        }

        if ( isset($totalTaxAmount) && !empty($totalTaxAmount)) {
            $json_array["taxAmount"]["amount"] = "$totalTaxAmount";
            $json_array["taxAmount"]["currency"] = "$currency";
        }


        $shippingAmount = 0 ;
        if ( isset($this->session->data['shipping_method']['cost']) && !empty($this->session->data['shipping_method']['cost'])) {
            $shippingAmount = $this->currency->format($this->session->data['shipping_method']['cost'], $order_info['currency_code'], $order_info['currency_value'], false);
        }

        if ( isset($shippingAmount) && !empty($shippingAmount)) {
            $json_array["shippingAmount"]["amount"] = "$shippingAmount";
            $json_array["shippingAmount"]["currency"] = "$currency";   
        }

        
        //call back urls
        $confirm_url = $setting_array['success_url'];
        $cancel_url = $setting_array['cancel_url'];
        $json_array["merchant"]["redirectConfirmUrl"] = $confirm_url;
        $json_array["merchant"]["redirectCancelUrl"] = $cancel_url;
        //Removed merchant reference from initial call.
        //$json_array["merchantReference"]=$order_info['order_id'];

        $json_array["extensions"]["pluginDetails"]["platform"] = "opencart";
        $json_array["extensions"]["pluginDetails"]["platformVersion"] = (string)VERSION;
        $json_array["extensions"]["pluginDetails"]["pluginVersion"] = (string)self::SCALAPAY_PLUGIN_VERSION;
        $json_array["extensions"]["pluginDetails"]["customized"] = "0";

        $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
        $logger->write($json_array); // again $data contains the data the need to be log

        $post_string = json_encode($json_array);

        $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
        $logger->write($post_string); // again $data contains the data the need to be log

        //Place an order on scalapay using payload data and other related information
        $mode = $this->config->get('payment_scalapay_mode');
        if ($mode) {
			$password = $this->config->get('payment_scalapay_live_encyptionkey');
            $ctp_url = $this->config->get('payment_scalapay_production_url') . '/v2/orders';
        } else {
			$password = $this->config->get('payment_scalapay_encyptionkey');
            $ctp_url = $this->config->get('payment_scalapay_test_url') . '/v2/orders';
        }
        $authorization = "Authorization: Bearer " . $password;


        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "$ctp_url",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $post_string,
            CURLOPT_HTTPHEADER => array(
                "Accept: application/json",
                "Content-Type: application/json",
                $authorization
            ),
        ));
        $response = curl_exec($curl);
        //verify, initial order data successfully placed or any error in data.
        if (!$response) {
            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write('Payment token request failed: ' . curl_error($curl) . '(' . curl_errno($curl) . ')'); // again $data contains the data the need to be log

        }

        curl_close($curl);

        $response_decode = json_decode($response, true);

        $checkoutUrl = "";
        if (isset($response_decode["checkoutUrl"])) {
            $checkoutUrl = $response_decode["checkoutUrl"];
        }
        if ($checkoutUrl == null) {
            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write("Payment token response parse error: $response"); // again $data contains the data the need to be log
            return false;
        } else {
            return $checkoutUrl;
        }

        if (isset($token['errors'])) {
            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write("Payment token request validation errors: $response"); // again $data contains the data the need to be log
            return false;
        }
        if (isset($token['response']) && isset($token['response']['message'])) {
            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write("Payment token request error: $response"); // again $data contains the data the need to be log
            return false;
        }

        if (isset($token['checkout']) && isset($token['checkout']['token'])) {
            return $token['checkout']['token'];
        } else {
            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write("No payment token in response: $response"); // again $data contains the data the need to be log
            return false;
        }
    }

    private function _language($lang_id)
    {
        $lang = substr($lang_id, 0, 2);
        $lang = strtolower($lang);
        return $lang;
    }
    /*
     * Order ID
     * Order Token
     * Order Total
     * This function will use to verify order placed properly and created successfully on both scalapay and site.
     * Also will update order related information
     */
    public function callback()
    {
        $this->language->load('extension/payment/scalapay');

        //Get order id from session, and also checking it from call back function.
        if (isset($this->session->data['order_id'])) {
            $order_id = $this->session->data['order_id'];
        }
        elseif (isset($_GET['cart_id']) && !empty($_GET['cart_id'])) {
            $order_id = $_GET['cart_id'];
        }
        else {
            $order_id = 0;
        }

        //Order token from call back function.
        $orderToken = "";
        if (isset($_GET["orderToken"]) && !empty($_GET["orderToken"])) {
            $orderToken = $_GET["orderToken"];
        }

        $status = "";
        if (isset($_GET["status"]) && !empty($_GET["status"])) {
            $status = $_GET["status"];
        }
        /******************Additional cart checks start****************/
        $proceed_for_order = false;
        $order_total_return = 0;

        if (isset($_GET['total'])) {
            $order_total_return = $_GET['total'];
        }

        //Validating order id and order data if order id is valid.
        if ($order_id != "" && $order_id > 0) {
            $currentGrandTotal = 0;
            $currentCartId = 0;
            $this->load->model('checkout/order');
            $order_info_return = $this->model_checkout_order->getOrder($order_id);
            $currentCartId = $order_info_return['order_id'];
            $orderAmount = $this->currency->format($order_info_return['total'], $order_info_return['currency_code'],
                $order_info_return['currency_value'], false);
            $orderAmount = (float)$orderAmount * pow(10,
                    (int)$this->currency->getDecimalPlace($order_info_return['currency_code']));
            $orderAmount = intval(strval($orderAmount));
            if ($orderAmount > 0) {
                $currentGrandTotal = $orderAmount / 100;
            }
            //extra check if user has the same cart details for which he/she paid the amount
            if ($order_id != "" && $order_total_return != 0) {
                $proceed_for_order = true;
            }
            if ($order_id != "" && $order_total_return > 0) {
                if ($order_id == $currentCartId && $currentGrandTotal == $order_total_return) {
                    $proceed_for_order = true;
                }
            }
        }
        /*******************Additional cart checks end***************/
        if ($status == "SUCCESS" && $proceed_for_order) {
            
            $mode = $this->config->get('payment_scalapay_mode');
            if ($mode) {
				$password = $this->config->get('payment_scalapay_live_encyptionkey');
                $ctp_url = $this->config->get('payment_scalapay_production_url') . '/v2/payments/capture';
            } else {
				$password = $this->config->get('payment_scalapay_encyptionkey');
                $ctp_url = $this->config->get('payment_scalapay_test_url') . '/v2/payments/capture';
            }

            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write('Order Token ' . $orderToken); // again $data contains the data the need to be log
            //Capture payment
            $authorization = "Authorization: Bearer " . $password;
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "$ctp_url",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "{  \n    \"token\": \"$orderToken\" , \"merchantReference\": \"$order_id\" \n}",
                CURLOPT_HTTPHEADER => array(
                    "Accept: application/json",
                    "Content-Type: application/json",
                    $authorization
                ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);
            $res = json_decode($response, true);

            $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
            $logger->write($res); // again $data contains the data the need to be log

            //if error
            if (isset($res["errorCode"]) && $res["errorCode"] != "") {

                $logger = new Log('scalapay_logs.log'); //just passed the file name as file_name.log
                $logger->write($res["errorCode"]); // again $data contains the data the need to be log

                $error_message =  $this->language->get('scapalay_checkout_failure_text');
                $this->session->data['error'] = $error_message;
                $failuer_url = $this->url->link('checkout/checkout', '', 'SSL');
                $this->response->redirect($failuer_url);
            }
            //if approved
            if (isset($res["status"]) && $res["status"] == "APPROVED") {
                $this->load->model('checkout/order');
                $order_status_id = $this->config->get('payment_scalapay_completed_status_id');
                $this->model_checkout_order->addOrderHistory($order_id, $order_status_id, "Scalapay order token: $orderToken", true);
                $this->updatePyamentMethodText($order_id);
                $this->response->redirect($this->url->link('checkout/success', '', 'SSL'));
            } else {
                $error_message =  $this->language->get('scapalay_checkout_failure_text');
                $this->session->data['error'] = $error_message;
                $failuer_url = $this->url->link('checkout/checkout', '', 'SSL');
                $this->response->redirect($failuer_url);
            }
        } else {
            $error_message =  $this->language->get('scapalay_checkout_failure_text');
            $this->session->data['error'] = $error_message;
            $failuer_url = $this->url->link('checkout/checkout', '', 'SSL');
            $this->response->redirect($failuer_url);
        }
    }

    private function updatePyamentMethodText($order_id)
    {
        $this->db->query("UPDATE `" . DB_PREFIX . "order` SET payment_method = 'Scalapay'  WHERE order_id = '" . (int)$order_id . "'");
    }
}
